<?php
/**********************************************************************
 * ProxmoxVPS developed. (26.03.19)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 **********************************************************************/

namespace ModulesGarden\Servers\ProxmoxCloudVps\App\Http\Actions;

use MGProvision\Proxmox\v2\models\Kvm;
use MGProvision\Proxmox\v2\models\User;
use MGProvision\Proxmox\v2\VmFactory;
use ModulesGarden\ProxmoxAddon\App\Services\ApiService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\ProductService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\UserService;
use ModulesGarden\ProxmoxAddon\App\Services\CloudService;
use ModulesGarden\Servers\ProxmoxCloudVps\App\Helpers\AppParams;
use ModulesGarden\Servers\ProxmoxCloudVps\App\Helpers\ProxmoxAddonValidator;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\App\Controllers\Instances\AddonController;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Traits\WhmcsParams;

class UnsuspendAccount extends AddonController
{
    use ApiService;
    use UserService;
    use ProductService;
    use WhmcsParams;

    public function execute($params = null)
    {
        if(!ProxmoxAddonValidator::isInstalled()){
            return ProxmoxAddonValidator::failAsString();
        }
        try
        {
            (new AppParams())->initFromParams($params);
            $cloud = new CloudService();
            //User Unsuspend
            $user        = $this->getUser();
            $userService = new User("{$user->username}@{$user->realm}");
            $userService->setApi($this->api());
            if ($userService->configuration()['enable'] == "0")
            {
                $userService->enable();
            }
            //VM Permission
            $permissions = $userService->permissions();
            foreach ($cloud->getVmModels() as $vmModel){
                $vmid        = $vmModel->vmid;
                $vm = (new VmFactory())->fromVmModel($vmModel);
                foreach ($permissions as $p)
                {
                    if ($p['path'] == "/vms/" . $vmid && $p['ugid'] == $userService->getUserid())
                    {
                        $userService->updatePermission($vmid, $p['roleid'], 1);
                    }
                }
                $role = $this->configuration()->getUserRole() ? $this->configuration()->getUserRole() : 'PVEVMUser';
                $userService->updatePermission($vmid, $role);
                if ($this->configuration()->isOnboot())
                {
                    $vm->updateConfig(["onboot" => 1]);
                }
                $status = $vm->status();
                if ($vm instanceof Kvm && $status['qmpstatus'] == "paused")
                {
                    $vm->resume();
                    continue;
                }
                if ($status['status'] == "running")
                {
                    continue;
                }
                else
                {
                    $vm->start();
                }
            }


            return "success";
        }
        catch (\Exception $ex)
        {
            return $ex->getMessage();
        }
    }
}